# spacetower_maneuver_planning_python_client
Maneuver Planning API

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Generator version: 7.6.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import spacetower_maneuver_planning_python_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import spacetower_maneuver_planning_python_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import spacetower_maneuver_planning_python_client
from spacetower_maneuver_planning_python_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.exoops.exotrail.space/maneuver-planning/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = spacetower_maneuver_planning_python_client.Configuration(
    host = "https://api.exoops.exotrail.space/maneuver-planning/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization: BearerAuth
configuration = spacetower_maneuver_planning_python_client.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with spacetower_maneuver_planning_python_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = spacetower_maneuver_planning_python_client.DefaultApi(api_client)
    orbital_transfer_with_power_system_request = spacetower_maneuver_planning_python_client.OrbitalTransferWithPowerSystemRequest() # OrbitalTransferWithPowerSystemRequest | 

    try:
        # Mean semi-major axis, eccentricity and inclination change with simulation of the power system
        api_response = api_instance.orbital_transfer_with_power_system(orbital_transfer_with_power_system_request)
        print("The response of DefaultApi->orbital_transfer_with_power_system:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->orbital_transfer_with_power_system: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.exoops.exotrail.space/maneuver-planning/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**orbital_transfer_with_power_system**](docs/DefaultApi.md#orbital_transfer_with_power_system) | **POST** /maneuver-planning/orbital-transfer-with-power-system | Mean semi-major axis, eccentricity and inclination change with simulation of the power system
*DefaultApi* | [**orbital_transfer_without_power_system**](docs/DefaultApi.md#orbital_transfer_without_power_system) | **POST** /maneuver-planning/orbital-transfer-without-power-system | Mean semi-major axis, eccentricity and inclination change


## Documentation For Models

 - [AnomalyType](docs/AnomalyType.md)
 - [AtmosphereModel](docs/AtmosphereModel.md)
 - [AtmosphereType](docs/AtmosphereType.md)
 - [AtmosphericDragPerturbation](docs/AtmosphericDragPerturbation.md)
 - [AttitudeBasedFiniteThrustSchedule](docs/AttitudeBasedFiniteThrustSchedule.md)
 - [AttitudeEphemeris](docs/AttitudeEphemeris.md)
 - [AttitudeEphemerisRequest](docs/AttitudeEphemerisRequest.md)
 - [AttitudeLaw](docs/AttitudeLaw.md)
 - [AttitudeLawType](docs/AttitudeLawType.md)
 - [AttitudeRepresentationType](docs/AttitudeRepresentationType.md)
 - [AttitudeSequence](docs/AttitudeSequence.md)
 - [AttitudeSequenceType](docs/AttitudeSequenceType.md)
 - [BatteryModel](docs/BatteryModel.md)
 - [BatteryPowerEphemeris](docs/BatteryPowerEphemeris.md)
 - [BatteryPowerEphemerisRequest](docs/BatteryPowerEphemerisRequest.md)
 - [BoxObjectWithPowerSystem](docs/BoxObjectWithPowerSystem.md)
 - [BoxObjectWithoutPowerSystem](docs/BoxObjectWithoutPowerSystem.md)
 - [CardanAngleEphemeris](docs/CardanAngleEphemeris.md)
 - [CartesianOrbit](docs/CartesianOrbit.md)
 - [CelestialBodyName](docs/CelestialBodyName.md)
 - [CircularOrbit](docs/CircularOrbit.md)
 - [CommonResultsFieldWithAndWithoutPowerSystem](docs/CommonResultsFieldWithAndWithoutPowerSystem.md)
 - [DateTriggeredAttitude](docs/DateTriggeredAttitude.md)
 - [DateTriggeredAttitudeSequence](docs/DateTriggeredAttitudeSequence.md)
 - [DutyCycleThrustArcsLength](docs/DutyCycleThrustArcsLength.md)
 - [EarthCenteredFrameId](docs/EarthCenteredFrameId.md)
 - [EarthOrientedManeuverAttitudeLaw](docs/EarthOrientedManeuverAttitudeLaw.md)
 - [EarthPotentialPerturbation](docs/EarthPotentialPerturbation.md)
 - [EphemerisGenerationRequestCommonFields](docs/EphemerisGenerationRequestCommonFields.md)
 - [EquinoctialOrbit](docs/EquinoctialOrbit.md)
 - [FieldDescription](docs/FieldDescription.md)
 - [FiniteThrustDefinition](docs/FiniteThrustDefinition.md)
 - [FixedStepIntegratorConfiguration](docs/FixedStepIntegratorConfiguration.md)
 - [FixedStepIntegratorType](docs/FixedStepIntegratorType.md)
 - [HarrisPriesterAtmosphere](docs/HarrisPriesterAtmosphere.md)
 - [InertialFrameId](docs/InertialFrameId.md)
 - [InertialLofType](docs/InertialLofType.md)
 - [IntegratorConfiguration](docs/IntegratorConfiguration.md)
 - [IntegratorType](docs/IntegratorType.md)
 - [KeplerianOrbit](docs/KeplerianOrbit.md)
 - [LofAttitudeLaw](docs/LofAttitudeLaw.md)
 - [ManeuverDirectionType](docs/ManeuverDirectionType.md)
 - [ManeuverExecutionReport](docs/ManeuverExecutionReport.md)
 - [ManeuverSchedule](docs/ManeuverSchedule.md)
 - [ManeuverScheduleType](docs/ManeuverScheduleType.md)
 - [ManeuverStrategy](docs/ManeuverStrategy.md)
 - [ManeuverStrategyNoThrustIntervalsInner](docs/ManeuverStrategyNoThrustIntervalsInner.md)
 - [ManeuverTarget](docs/ManeuverTarget.md)
 - [ManeuverTargetElementsDelta](docs/ManeuverTargetElementsDelta.md)
 - [ManeuverTargetElementsValue](docs/ManeuverTargetElementsValue.md)
 - [ManeuverTargetType](docs/ManeuverTargetType.md)
 - [MassEphemeris](docs/MassEphemeris.md)
 - [MassEphemerisRequest](docs/MassEphemerisRequest.md)
 - [MeanOrbitEphemeris](docs/MeanOrbitEphemeris.md)
 - [MeanOrbitEphemerisRequest](docs/MeanOrbitEphemerisRequest.md)
 - [MeanOsculatingOrbitType](docs/MeanOsculatingOrbitType.md)
 - [NadirPointingLaw](docs/NadirPointingLaw.md)
 - [NrlMsise00Atmosphere](docs/NrlMsise00Atmosphere.md)
 - [Orbit](docs/Orbit.md)
 - [OrbitType](docs/OrbitType.md)
 - [OrbitalParameterType](docs/OrbitalParameterType.md)
 - [OrbitalTransferRequest](docs/OrbitalTransferRequest.md)
 - [OrbitalTransferWithPowerSystemRequest](docs/OrbitalTransferWithPowerSystemRequest.md)
 - [OrbitalTransferWithPowerSystemResult](docs/OrbitalTransferWithPowerSystemResult.md)
 - [OrbitalTransferWithoutPowerSystemRequest](docs/OrbitalTransferWithoutPowerSystemRequest.md)
 - [OrbitalTransferWithoutPowerSystemResult](docs/OrbitalTransferWithoutPowerSystemResult.md)
 - [OsculatingOrbitEphemeris](docs/OsculatingOrbitEphemeris.md)
 - [OsculatingOrbitEphemerisRequest](docs/OsculatingOrbitEphemerisRequest.md)
 - [OsculatingToMeanConversionTheory](docs/OsculatingToMeanConversionTheory.md)
 - [OutputEphemerisWithPowerSystem](docs/OutputEphemerisWithPowerSystem.md)
 - [OutputEphemerisWithoutPowerSystem](docs/OutputEphemerisWithoutPowerSystem.md)
 - [Perturbation](docs/Perturbation.md)
 - [PerturbationType](docs/PerturbationType.md)
 - [PowerSystem](docs/PowerSystem.md)
 - [ProblemDetail](docs/ProblemDetail.md)
 - [PropulsionPowerModel](docs/PropulsionPowerModel.md)
 - [QuaternionEphemeris](docs/QuaternionEphemeris.md)
 - [ReflectionAbsorptionCoefficients](docs/ReflectionAbsorptionCoefficients.md)
 - [RotatingLocalFrameId](docs/RotatingLocalFrameId.md)
 - [SimulationConfiguration](docs/SimulationConfiguration.md)
 - [SimulationWithPowerEphemerisRequest](docs/SimulationWithPowerEphemerisRequest.md)
 - [SimulationWithoutPowerEphemerisRequest](docs/SimulationWithoutPowerEphemerisRequest.md)
 - [SingleArcThrustPatternDefinition](docs/SingleArcThrustPatternDefinition.md)
 - [SolarArrayGeometry](docs/SolarArrayGeometry.md)
 - [SolarRadiationPressurePerturbation](docs/SolarRadiationPressurePerturbation.md)
 - [SunEnhancedManeuverAttitudeLaw](docs/SunEnhancedManeuverAttitudeLaw.md)
 - [SunPointingLaw](docs/SunPointingLaw.md)
 - [TLE](docs/TLE.md)
 - [ThirdBodiesGravityPerturbation](docs/ThirdBodiesGravityPerturbation.md)
 - [ThrustArcsLength](docs/ThrustArcsLength.md)
 - [ThrustDurationThrustArcsLength](docs/ThrustDurationThrustArcsLength.md)
 - [ThrustPatternConfiguration](docs/ThrustPatternConfiguration.md)
 - [ThrustVectorEphemeris](docs/ThrustVectorEphemeris.md)
 - [ThrustVectorEphemerisRequest](docs/ThrustVectorEphemerisRequest.md)
 - [Thruster](docs/Thruster.md)
 - [TimestampedOutputData](docs/TimestampedOutputData.md)
 - [TwoArcsThrustPatternDefinition](docs/TwoArcsThrustPatternDefinition.md)
 - [TwoLineElementOrbit](docs/TwoLineElementOrbit.md)
 - [VariableStepIntegratorConfiguration](docs/VariableStepIntegratorConfiguration.md)
 - [VariableStepIntegratorType](docs/VariableStepIntegratorType.md)
 - [Vector3D](docs/Vector3D.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="BearerAuth"></a>
### BearerAuth

- **Type**: Bearer authentication


## Author




