# coding: utf-8

"""
    Maneuver Planning API

    Maneuver Planning API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from spacetower_maneuver_planning_python_client.models.finite_thrust_definition import FiniteThrustDefinition
from spacetower_maneuver_planning_python_client.models.maneuver_schedule import ManeuverSchedule
from spacetower_maneuver_planning_python_client.models.maneuver_schedule_type import ManeuverScheduleType
from typing import Optional, Set
from typing_extensions import Self

class AttitudeBasedFiniteThrustSchedule(ManeuverSchedule):
    """
    Finite burns schedule with attitude given by the attitude law sequence
    """ # noqa: E501
    dated_finite_thrust_schedule: Optional[List[FiniteThrustDefinition]] = Field(default=None, alias="datedFiniteThrustSchedule")
    __properties: ClassVar[List[str]] = ["maneuverScheduleType", "datedFiniteThrustSchedule"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AttitudeBasedFiniteThrustSchedule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in dated_finite_thrust_schedule (list)
        _items = []
        if self.dated_finite_thrust_schedule:
            for _item in self.dated_finite_thrust_schedule:
                if _item:
                    _items.append(_item.to_dict())
            _dict['datedFiniteThrustSchedule'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AttitudeBasedFiniteThrustSchedule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "maneuverScheduleType": obj.get("maneuverScheduleType"),
            "datedFiniteThrustSchedule": [FiniteThrustDefinition.from_dict(_item) for _item in obj["datedFiniteThrustSchedule"]] if obj.get("datedFiniteThrustSchedule") is not None else None
        })
        return _obj


