# coding: utf-8

"""
    Maneuver Planning API

    Maneuver Planning API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from spacetower_maneuver_planning_python_client.models.attitude_ephemeris import AttitudeEphemeris
from spacetower_maneuver_planning_python_client.models.battery_power_ephemeris import BatteryPowerEphemeris
from spacetower_maneuver_planning_python_client.models.mass_ephemeris import MassEphemeris
from spacetower_maneuver_planning_python_client.models.mean_orbit_ephemeris import MeanOrbitEphemeris
from spacetower_maneuver_planning_python_client.models.osculating_orbit_ephemeris import OsculatingOrbitEphemeris
from spacetower_maneuver_planning_python_client.models.thrust_vector_ephemeris import ThrustVectorEphemeris
from typing import Optional, Set
from typing_extensions import Self

class OutputEphemerisWithPowerSystem(BaseModel):
    """
    OutputEphemerisWithPowerSystem
    """ # noqa: E501
    attitude_ephemeris: Optional[AttitudeEphemeris] = Field(default=None, alias="attitudeEphemeris")
    thrust_vector_ephemeris: Optional[ThrustVectorEphemeris] = Field(default=None, alias="thrustVectorEphemeris")
    mass_ephemeris: Optional[MassEphemeris] = Field(default=None, alias="massEphemeris")
    osculating_orbit_ephemeris: Optional[OsculatingOrbitEphemeris] = Field(default=None, alias="osculatingOrbitEphemeris")
    mean_orbit_ephemeris: Optional[MeanOrbitEphemeris] = Field(default=None, alias="meanOrbitEphemeris")
    battery_power_ephemeris: Optional[BatteryPowerEphemeris] = Field(default=None, alias="batteryPowerEphemeris")
    __properties: ClassVar[List[str]] = ["attitudeEphemeris", "thrustVectorEphemeris", "massEphemeris", "osculatingOrbitEphemeris", "meanOrbitEphemeris", "batteryPowerEphemeris"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OutputEphemerisWithPowerSystem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of attitude_ephemeris
        if self.attitude_ephemeris:
            _dict['attitudeEphemeris'] = self.attitude_ephemeris.to_dict()
        # override the default output from pydantic by calling `to_dict()` of thrust_vector_ephemeris
        if self.thrust_vector_ephemeris:
            _dict['thrustVectorEphemeris'] = self.thrust_vector_ephemeris.to_dict()
        # override the default output from pydantic by calling `to_dict()` of mass_ephemeris
        if self.mass_ephemeris:
            _dict['massEphemeris'] = self.mass_ephemeris.to_dict()
        # override the default output from pydantic by calling `to_dict()` of osculating_orbit_ephemeris
        if self.osculating_orbit_ephemeris:
            _dict['osculatingOrbitEphemeris'] = self.osculating_orbit_ephemeris.to_dict()
        # override the default output from pydantic by calling `to_dict()` of mean_orbit_ephemeris
        if self.mean_orbit_ephemeris:
            _dict['meanOrbitEphemeris'] = self.mean_orbit_ephemeris.to_dict()
        # override the default output from pydantic by calling `to_dict()` of battery_power_ephemeris
        if self.battery_power_ephemeris:
            _dict['batteryPowerEphemeris'] = self.battery_power_ephemeris.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OutputEphemerisWithPowerSystem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "attitudeEphemeris": AttitudeEphemeris.from_dict(obj["attitudeEphemeris"]) if obj.get("attitudeEphemeris") is not None else None,
            "thrustVectorEphemeris": ThrustVectorEphemeris.from_dict(obj["thrustVectorEphemeris"]) if obj.get("thrustVectorEphemeris") is not None else None,
            "massEphemeris": MassEphemeris.from_dict(obj["massEphemeris"]) if obj.get("massEphemeris") is not None else None,
            "osculatingOrbitEphemeris": OsculatingOrbitEphemeris.from_dict(obj["osculatingOrbitEphemeris"]) if obj.get("osculatingOrbitEphemeris") is not None else None,
            "meanOrbitEphemeris": MeanOrbitEphemeris.from_dict(obj["meanOrbitEphemeris"]) if obj.get("meanOrbitEphemeris") is not None else None,
            "batteryPowerEphemeris": BatteryPowerEphemeris.from_dict(obj["batteryPowerEphemeris"]) if obj.get("batteryPowerEphemeris") is not None else None
        })
        return _obj


