# coding: utf-8

"""
    Maneuver Planning API

    Maneuver Planning API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from spacetower_maneuver_planning_python_client.models.thrust_pattern_configuration import ThrustPatternConfiguration
from typing import Optional, Set
from typing_extensions import Self

class TwoArcsThrustPatternDefinition(ThrustPatternConfiguration):
    """
    two arcs
    """ # noqa: E501
    number_of_shift_orbits: Optional[StrictInt] = Field(default=0, description="In two-burn strategies involving symmetric burns arcs, these can be shifted from one another by a whole number of revolutions.  This is described by the \"shift orbits\" parameter ", alias="numberOfShiftOrbits")
    thrust_arcs_center: Optional[StrictStr] = Field(default='ASCENDING_AND_DESCENDING_NODES', alias="thrustArcsCenter")
    __properties: ClassVar[List[str]] = ["thrustArcsNumber", "numberOfThrustOrbits", "numberOfRestOrbits", "numberOfShiftOrbits", "thrustArcsCenter"]

    @field_validator('thrust_arcs_center')
    def thrust_arcs_center_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ASCENDING_AND_DESCENDING_NODES', 'APOGEE_AND_PERIGEE', 'ASCENDING_AND_DESCENDING_ANTINODES', 'MEAN_LONGITUDE', 'CUSTOM']):
            raise ValueError("must be one of enum values ('ASCENDING_AND_DESCENDING_NODES', 'APOGEE_AND_PERIGEE', 'ASCENDING_AND_DESCENDING_ANTINODES', 'MEAN_LONGITUDE', 'CUSTOM')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TwoArcsThrustPatternDefinition from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TwoArcsThrustPatternDefinition from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "thrustArcsNumber": obj.get("thrustArcsNumber") if obj.get("thrustArcsNumber") is not None else 'TWO',
            "numberOfThrustOrbits": obj.get("numberOfThrustOrbits") if obj.get("numberOfThrustOrbits") is not None else 1,
            "numberOfRestOrbits": obj.get("numberOfRestOrbits") if obj.get("numberOfRestOrbits") is not None else 0,
            "numberOfShiftOrbits": obj.get("numberOfShiftOrbits") if obj.get("numberOfShiftOrbits") is not None else 0,
            "thrustArcsCenter": obj.get("thrustArcsCenter") if obj.get("thrustArcsCenter") is not None else 'ASCENDING_AND_DESCENDING_NODES'
        })
        return _obj


